/* Simple test for rexxutil.library 33.23 (BETA)
 *
 * rexxutil.library is an ARexx function host that adds clipboard access,
 * environment variables, and other misc. utility to the ARexx language.
 *
 * Written by David N. Junod
 */

/* Load the ARexx utility library */
IF ~SHOW('L','rexxutil.library') THEN
   CALL ADDLIB('rexxutil.library',0,-30)

   DoReads = 1
   DoWrites = 1
   ClipUnit = 2
   PrimaryClip = 0

   SAY '--------------------------------------------'

   SAY 'Query the status of the clipboard'
   CALL QueryClip(clipstat.,STEM,PrimaryClip)

   SAY 'Contents Type:' clipstat.form
   SAY '      Clip ID:' clipstat.clipid

   SAY '--------------------------------------------'
   /* Access the clipboard with a simple variable */

   IF DoReads
   THEN DO
	SAY 'Read Clipboard' ClipUnit 'into a simple variable'
	clip = ReadClip(,VAR,,ClipUnit)
	IF clip = ""	THEN SAY "Clipboard empty"
			ELSE SAY clip
	END

   IF DoWrites
   THEN DO
	SAY 'Write "simple test"'
	CALL WriteClip("Simple test...",VAR,,ClipUnit,"ARexx","util.rexx")
	END

   SAY '--------------------------------------------'

   IF DoReads
   THEN DO
	SAY 'Read Clipboard' PrimaryClip 'into a simple variable'
	clip = ReadClip(,,,PrimaryClip)
	IF clip = ""	THEN SAY "Clipboard empty"
			ELSE SAY clip
	END

   IF DoWrites
   THEN DO
	SAY 'Write that same simple variable back into the clipboard'
	CALL WriteClip(clip,VAR,,PrimaryClip,"ARexx","util.rexx")
	END

   SAY '--------------------------------------------'

   IF DoReads
   THEN DO
	SAY 'Read Clipboard into a stem variable'
	CALL ReadClip(clipstem.,STEM,,PrimaryClip)

	SAY 'Contents Type:' clipstem.form
	SAY '       Author:' clipstem.auth
	SAY '      Project:' clipstem.name
	SAY '       ClipID:' clipstem.clipid
	SAY '        Lines:' clipstem.0
	SAY ' # Characters:' clipstem.characters

	/* clipstem.0 contains the number of lines read in */
	DO i = 1 TO clipstem.0
	    SAY clipstem.i
	    clipstem.i = REVERSE(clipstem.i)
	    END
	END

   SAY '--------------------------------------------'

   IF DoWrites
   THEN DO
	SAY 'Write the stem variable back in with each line reversed'
	CALL WriteClip(clipstem.,STEM,,PrimaryClip,"ARexx","util.rexx")
	SAY '       ClipID: 'clipstem.clipid
	END

   SAY '--------------------------------------------'
